# Creating a gcc crosscompiler on linux, for gp32
# written 20.7.2004 Mirko Roller

wget ftp://ftp.mpi-sb.mpg.de/pub/gnu/mirror/ftp.gnu.org/gnu/binutils/binutils-2.15.tar.bz2
wget ftp://ftp.mpi-sb.mpg.de/pub/gnu/mirror/ftp.gnu.org/gnu/gcc/gcc-3.4.1/gcc-3.4.1.tar.bz2
wget ftp://sources.redhat.com/pub/newlib/newlib-1.12.0.tar.gz

mkdir /opt/gp-arm-elf
mkdir /opt/gp-arm-elf/bin
cp gp32-bin-tools.tgz /opt/gp-arm-elf/bin
cd /opt/gp-arm-elf/bin
tar xvfz gp32-bin-tools.tgz
rm -rf gp32-bin-tools.tgz
cd -

declare -x CFLAGS="-s "
tar xvfj binutils-2.15.tar.bz2
cd binutils-2.15
./configure --target=arm-elf --prefix=/opt/gp-arm-elf && make
make install
cd ..


tar xvfz newlib-1.12.0.tar.gz
cp syscalls.c.spivvy newlib-1.12.0/newlib/libc/sys/arm/syscalls.c
tar xvfj gcc-3.4.1.tar.bz2
cd gcc-3.4.1
ln -s ../newlib-1.12.0/newlib .
mkdir build
cd build
CFLAGS="-pipe -s "
../configure --target=arm-elf --prefix=/opt/gp-arm-elf --with-cpu=arm9 --disable-threads --enable-languages=c,c++ --with-newlib --disable-multilib --with-gnu-ld --with-gnu-as
make all \
  CFLAGS_FOR_TARGET="-DTAG_CFLAGS_FOR_TARGET -s -march=armv4t -marm -msoft-float -ffast-math -fshort-enums -mstructure-size-boundary=8 -O2" \
  CXXFLAGS_FOR_TARGET="-DTAG_CXXFLAGS_FOR_TARGET -s -march=armv4t -marm -msoft-float -ffast-math -fshort-enums -mstructure-size-boundary=8 -O -fno-implicit-templates" \
  LIBCFLAGS_FOR_TARGET="-DTAG_LIBCFLAGS_FOR_TARGET -s -march=armv4t -marm -msoft-float -ffast-math -fshort-enums -mstructure-size-boundary=8 -O2" \
  LIBGCC2_CFLAGS="-DIN_GCC -DCROSS_COMPILE -DIN_LIBGCC2 -D__GCC_FLOAT_NOT_NEEDED -W -Wall -Wwrite-strings -Wstrict-prototypes -Wmissing-prototypes -isystem ./include  -Dinhibit_libc -fno-inline -DTAG_LIBGCC_FLAGS -s -march=armv4t -marm -msoft-float -O2 -ffast-math -fshort-enums -mstructure-size-boundary=8"

make install
cd ../..

rm -rf binutils-2.15 newlib-1.12.0 gcc-3.4.1


echo 
echo Add the Line:
echo 'export PATH=/opt/gp-arm-elf/bin:$PATH'
echo to ~/.bash_profile
echo 
